#include<iostream>
using namespace std;
int main ()
{
    int N;
    cin>>N;
    bool mas[N+1][N+1];
    for (int i=1; i<=N; i++)
    {
        for (int q=1; q<=N; q++)
        {
            mas[i][q]=0;
        }
    }
    for (int i=0; i<N-1; i++)
    {
        int U, V;
        cin>>U>>V;
        mas[U][V]=1;
    }
    int Q;
    cin>>Q;
    int spisuk[Q];
    for (int i=0; i<Q; i++)
    {
        cin>>spisuk[i];
    }
    for (int i=0; i<Q; i++)
    {
        bool dali[N+1];
        for (int i=0; i<N+1; i++)
        {
            dali[i]=false;
        }
        for  (int q=1; q<=N; q++)
        {
            if (mas[spisuk[i]][q]==1)
            {
                dali[q]=true;
                for  (int z=1; z<=N; z++)
                {
                    if (mas[q][z]==1)
                    {
                        dali[z]=true;
                        for  (int p=1; p<=N; p++)
                        {
                            if (mas[z][p]==1)
                            {
                                dali[p]=true;
                                for  (int a=1; a<=N; a++)
                                {
                                    if (mas[p][a]==1)
                                    {
                                        dali[a]=true;
                                        for  (int b=1; b<=N; b++)
                                        {
                                            if (mas[a][b]==1)
                                            {
                                                dali[b]=true;
                                                for  (int c=1; c<=N; c++)
                                                {
                                                    if (mas[b][c]==1)
                                                    {
                                                        dali[c]=true;
                                                        for  (int d=1; d<=N; d++)
                                                        {
                                                            if (mas[c][d]==1)
                                                            {
                                                                dali[d]=true;
                                                                for  (int e=1; e<=N; e++)
                                                                {
                                                                    if (mas[d][e]==1)
                                                                    {
                                                                        dali[e]=true;
                                                                        for  (int f=1; f<=N; f++)
                                                                        {
                                                                            if (mas[e][f]==1)
                                                                            {
                                                                                dali[f]=true;

                                                                            }
                                                                        }

                                                                    }
                                                                }

                                                            }
                                                        }

                                                    }
                                                }

                                            }
                                        }

                                    }
                                }

                            }
                        }

                    }
                }
            }
        }
        int br=0;
        for (int a=1; a<=N; a++)
        {
            if (dali[a]==true) br++;
        }
        cout<<br<<endl;
    }
    return 0;
}
